#include "functions.inc"
#include "image_functions.inc"



#declare f_adjust_smooth =
function(value_0) {
select(
    value_0,
    0,
    select(
        value_0 - 1,
        (-cos(pi*value_0) + 1)/2,
        1
    )
)
}







#macro generate_pattern_step(t_b0, t_b1, bump_amplitude, noise_space_size)

    
    
    
    
    
    
    // HtuʤWɪ
    #local f_t_rise_mockup =
    function (var_t) {
    (
    (1 + 2*bump_amplitude)* var_t - bump_amplitude*(t_b0 + t_b1) - t_b0
    )/(t_b1 - t_b0)
    }
    
    
    
    
    
    
    
    // ---- apply noise ------------
    
    
    
    
    
    
    #local f_noise_apply =
    function(x, y, z) {
    f_imitate_max_r2(
    f_ripples(x/noise_space_size, y/noise_space_size, 0),
    f_bumps(x/noise_space_size, y/noise_space_size, 0)
    )
    }
    
    
    
    
    
    #local f_noise_t_combine =
    function(x, y, z, time_value) {
    f_t_rise_mockup(time_value) + bump_amplitude *f_noise_apply(x, y, 0)
    }
    
    
    
    
    
    // ---- apply noise end define------------
    
    
    #local f_change_vs_value =
    function (x,y, value_input) {
    select(
        value_input,
        0,
        select(
            value_input - 1,
            value_input,
            1
        )
    )
    }
    
    
    #local f_output =
    function (x, y, time_value) {
    f_change_vs_value(
    x, y,
    f_adjust_smooth(f_noise_t_combine(x, y, z, time_value))
    )
    }

    f_output





#end










