#include "addition_tools.inc"

#include "angular_shape_distortion_macros.inc"
#include "bump_pattern_base_function_macros.inc"
#include "bump_pattern_composite_function_macros.inc"






#macro generate_bump_follow_height_trend_f(height_vs_r_ratio)
    
    #local rat = abs(height_vs_r_ratio);
    
    // CONE@NNn
    #local f_output =
    function(x, y, z) {
    sqrt(1 + rat*rat)
    *(rat*rat *z - x*x - y*y)
    /pow(rat, 3)
    }
    
    f_output

#end









